<?
/*
libReplay HTTP Testing Framework
(c) Schien Dong, Antradar Software
Last Modified; January 02, 2010
*/

function checktcp($packet){
	$frameheaders=unpack('C12/vtype',$packet);
	if ($frameheaders['type']!=8) {
		//echo "not IP\r\n";
		return '';
	}
	
	$ipheader=substr($packet,14,20);
	$ipheaders=unpack('Cheaderlen/C8/Cprotocol',$ipheader);
	$protocol=$ipheaders['protocol'];
	
	if ($protocol!=6) return ''; //not TCP
	
	//bypass packets that are too short (SYN/FIN)
	$tcpheader=substr($packet,34,20);
	$tcpheaders=unpack('C13/Cflag',$tcpheader);
	$flag=$tcpheaders['flag'];
	$headersize=54;
	$data=substr($packet,$headersize,strlen($packet)-$headersize);

	if ($flag==1||$flag==2) return '';
	
	$tcps=explode(' ',$data);
	//print_r($tcpheaders);
	$method=$tcps[0];
	
	if ($method!='GET'&&$method!='POST') {
		$method='ASM';
	}

	return array('method'=>$method,'data'=>$data);	
}

function render_silk($requests){
	
	foreach ($requests as $req){
		$line='';
		$uri=$req['uri'];
		$diff=$req['diff'];
		$method=$req['method'];
		$postdata=$req['postdata'];
		$contenttype=$req['contenttype'];
	
		$line="WebUrl(\"$uri\",$diff);\r\n";
	
		if ($method=='POST') $line="WebUrlPostBin(\"$uri\",\"$postdata\",STRING_COMPLETE,\"$contenttype\",$diff);\r\n";	
	
		echo "$line\r\n";
	}
}

function parsetcp($tcp,$diff=0){
	$res=array();
	$tcps=explode(' ',$tcp);
	$method=$tcps[0];
	$diff=sprintf('%.1f',$diff);
	
	if ($method!='GET'&&$method!='POST') return '';
	
	$url=$tcps[1];
	preg_match('/Host:\s*(\S+)/',$tcp,$matches);
	$host=$matches[1];
	
	$uri="http://$host".$url;
	$postdata='';
	
	$line="WebUrl(\"$uri\",$diff);\r\n";

	preg_match('/Referer:\s*(\S+)/',$tcp,$matches);
	$referer=$matches[1];
	preg_match('/User-Agent:\s*([\S\s]+?)$/',$tcp,$matches);
	$agents=explode("\n",$matches[1]);
	$agent=trim($agents[0]);

	preg_match('/Content-Type:\s*(\S+)/',$tcp,$matches);
	$contenttype=$matches[1];
	
	if ($method=='POST'){
		//preg_match('/Content-Length:\s*(\d+)\s*([\S\s]+)$/',$tcp,$matches);
		//$datalen=$matches[1];
		$tcps=explode("\r\n\r\n",$tcp);
		$postdata=$tcps[1];
	}

	$res=array('method'=>$method,'uri'=>$uri,'postdata'=>$postdata,'contenttype'=>$contenttype,'diff'=>$diff,'referer'=>$referer,'agent'=>$agent);
	return $res;

}


function parsepcap($fn){
	
	$packets=array();
	
	$f=fopen($fn,'rb');
	
	$header=unpack('Vmagic/v2versions/V3/Vnetwork',fread($f,24));
	
	$lasttime=0;
	
	$requests=array();

	while (!feof($f)){
		$c=fread($f,16);
		if (strlen($c)<16) break;
		$packetheader=unpack('V2/Vslen/Vrlen',$c);
		$packetlength=$packetheader['rlen'];
		if ($packetlength==0) break;
		$packetdata=fread($f,$packetlength);
		$time=$packetheader[1];
		if ($lasttime==0) $lasttime=$time;
		$diff=$time-$lasttime;

		$tcpdata=checktcp($packetdata);
		if (!is_array($tcpdata)) continue;
		$tcp=$tcpdata['data'];
		$method=$tcpdata['method'];
		
		if (trim($tcp)=='') continue;
		
		$lasttime=$time;
		if ($method!='ASM'){		
			$packet=array('diff'=>$diff,'tcp'=>$tcp);
			array_push($packets,$packet);		
		} else {
			$packets[count($packets)-1]['tcp'].=$tcp;	
		}
		
	}
	
	foreach ($packets as $packet){
		$diff=$packet['diff'];
		$tcp=$packet['tcp'];
		$req=parsetcp($tcp,$diff);
		if (!is_array($req)) continue;
						
		array_push($requests,$req);
		
	}

	fclose($f);
	return $requests;
}

function parsecookies($fn){
	if (!file_exists($fn)) return '';
	$f=fopen($fn,'rt');
	$lines='';
	while (!feof($f)){
		$line=fgets($f);
		if (trim($line)=='') continue;
		if (preg_match('/^#/',$line)) continue;
		if (preg_match('/deleted$/',$line)) continue;
		preg_match('/(\S+)\s+(\S+)$/',$line,$matches);
		$line=$matches[1].'='.$matches[2];
		if ($lines=='') $lines=$line; else $lines.="; $line";
	}
	fclose($f);
	return $lines;
}

function sendrequest($req){

	$uri=$req['uri'];
	$method=$req['method'];
	$contenttype=$req['contenttype'];
	$postdata=$req['postdata'];
	$referer=$req['referer'];
	$agent=$req['agent'];

	$curl=curl_init($uri);
	//curl_setopt($curl,CURLOPT_VERBOSE,1);
	curl_setopt($curl,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($curl,CURLOPT_HEADER,1);
	curl_setopt($curl,CURLOPT_FOLLOWLOCATION,0);
	curl_setopt($curl,CURLOPT_COOKIEJAR,'replaycookie');
	$cookies=parsecookies('replaycookie');
	curl_setopt($curl,CURLOPT_COOKIE,$cookies);
	if ($agent!='') curl_setopt($curl,CURLOPT_USERAGENT,$agent);

	usleep(5000);

	$start=microtime(1);

	if ($method=='POST'){
		curl_setopt($curl,CURLOPT_POST,1);
		curl_setopt($curl,CURLOPT_POSTFIELDS,$postdata);
	}
	
	if ($referer!='') curl_setopt($curl,CURLOPT_REFERER,$referer);

	$res=curl_exec($curl);
	curl_close($curl);


	//echo "$res\r\n\r\n";
	$end=microtime(1);
	$waittime=$end-$start;
	$bytes=strlen($res);
	$reqsize=strlen($uri)+strlen($postdata)+strlen($cookies)+0;
	//if ($postdata!=''||preg_match('/index/',$uri)) echo "\r\n$uri\r\n[$res]\r\n";

	return array('bytes'=>$bytes,'waittime'=>$waittime,'reqsize'=>$reqsize);	
}

//input: HTTP requests
function benchmark($requests,$iterations){
	if (file_exists('replaycookie')) unlink('replaycookie');
	$res=array();

	$steps=count($requests)*$iterations;
	$step=0;

	echo "\r\n";

	for($i=0;$i<$iterations;$i++){


	foreach($requests as $req){
		echo "\r".sprintf('%.1f%%      ',$step/$steps*100);ob_flush();
		$uri=$req['uri'];
//echo "\t>>$uri\r\n";
		$method=$req['method'];
		$contenttype=$req['contenttype'];
		$postdata=$req['postdata'];
		
		if (!is_array($res[$uri])) $res[$uri]=array('count'=>0,'totalbytes'=>0,'totalwaittime'=>0,'totalreqsize'=>0);
		$res[$uri]['count']++;
		$measure=sendrequest($req);
		$bytes=$measure['bytes'];
		$waittime=$measure['waittime'];
		$reqsize=$measure['reqsize'];
		$res[$uri]['totalreqsize']+=$reqsize;
		$res[$uri]['totalbytes']+=$bytes;
		$res[$uri]['totalwaittime']+=$waittime;
		$step++;	
	}

	}

	foreach($res as $uri=>$r){
		$res[$uri]['averagebytes']=$r['totalbytes']/$r['count'];
		$res[$uri]['averagewaittime']=$r['totalwaittime']/$r['count'];
		$res[$uri]['averagereqsize']=$r['totalreqsize']/$r['count'];
	}
	
	echo "\r            \r\n";

	if (file_exists('replaycookie')) unlink('replaycookie');

	return $res;
}

//input: benchmark results
function report_rank($res,$field,$max=null){

	$tops=rankfields($res,$field);
	
	$count=0;

	foreach ($tops as $uri=>$top){
		$val=$top[$field];
		//$val=sprintf('%d',$val);
		echo "$val\t$uri\r\n";
		$count++;
		if ($max!=null&&$count>$max) break;
	}

}


function rankfields($res,$field){
	$ranked=$res;
	uasort($ranked,create_function('$a,$b','if ($a["'.$field.'"]==$b["'.$field.'"]) return 0;return $a["'.$field.'"]<$b["'.$field.'"]?1:-1;'));
	return $ranked;
}

/*
//Sample Use

include 'libreplay.php';
$req=parsepcap('simple.pcap');

//render_silk($req);

$res=benchmark($req,1);

echo "\r\nTop Bandwidth Consumers\r\n=======\r\n";
report_rank($res,'totalbytes');

echo "\r\nSlowest Pages\r\n=======\r\n";
report_rank($res,'totalwaittime');

*/
